{- Heist.hs (c) 2009 Claude Heiland-Allen <claude@mathr.co.uk> -}

module VCF where

-- Basic requirements
import qualified Prelude as P
import Prelude (pi)
import Heist

sr = 44100

vcf = -- Pure-data's [vcf~]
  Put f "x" `Seq`
  Put f "f" `Seq`
  Put f "q" `Seq`
  (Get f "two" * Get f "f" * Get f "pi" / Get f "sr"  `Seq` Put f "a") `Seq`
  (Get f "one" - Get f "a" / Get f "q"                `Seq` Put f "r") `Seq`
  (Get f "r" * cos (Get f "a")                        `Seq` Put f "c") `Seq`
  (Get f "r" * sin (Get f "a")                        `Seq` Put f "s") `Seq`
  ((Get f "two" - Get f "two" / (Get f "two" + Get f "q")) *
   (Get f "one" - Get f "r")                          `Seq` Put f "k") `Seq`
  w `Rec` (wire "2" `Par` wire "3")
  where
    w = -- recursive part of the filter
      Put f "u" `Seq`
      Put f "v" `Seq`
      (Get f "k" * Get f "x" + Get f "c" * Get f "u" - Get f "s" * Get f "v") `Par`
                              (Get f "s" * Get f "u" + Get f "c" * Get f "v")

process = -- some processing
  (const pi    `Seq` Put f "pi")  `Seq`
  (const 44100 `Seq` Put f "sr")  `Seq`
  (const 1     `Seq` Put f "one") `Seq`
  (const 2     `Seq` Put f "two") `Seq`
  vcf `Seq` wire "1" `Par` Put f "cut"

